package cat.hack3.codingtests.marsrover.gps;

import cat.hack3.codingtests.marsrover.api.cartography.Coordinates.Latitude;
import cat.hack3.codingtests.marsrover.api.cartography.Coordinates.Longitude;

public class MapIncrementalPositionResolver {

    private final int firstPositionInMap;
    private final int incrementUnit;
    private final long maximumYPosition;
    private final long maximumXPosition;

    public MapIncrementalPositionResolver(int firstPositionInMap, int incrementUnit, long maximumYPosition, long maximumXPosition) {
        this.firstPositionInMap = firstPositionInMap;
        this.incrementUnit = incrementUnit;
        this.maximumYPosition = maximumYPosition;
        this.maximumXPosition = maximumXPosition;
    }

    long getIncremented(Longitude longitude) {
        return getIncremented(longitude.pointer(), maximumXPosition);
    }

    long getIncremented(Latitude latitude) {
        return getIncremented(latitude.pointer(), maximumYPosition);
    }

    private long getIncremented(long currentPosition, long threshold) {
        return currentPosition + incrementUnit > threshold
                ? firstPositionInMap
                : ++currentPosition;
    }

    long getDecremented(Latitude latitude) {
        return getDecremented(latitude.pointer(), maximumYPosition);
    }

    long getDecremented(Longitude longitude) {
        return getDecremented(longitude.pointer(), maximumYPosition);
    }

    private long getDecremented(long currentPosition, long threshold) {
        return currentPosition - incrementUnit < firstPositionInMap
                ? threshold
                : --currentPosition;
    }
}
