package cat.hack3.codingtests.marsrover.api;

import cat.hack3.codingtests.marsrover.api.cartography.Coordinates;
import cat.hack3.codingtests.marsrover.api.cartography.Direction;
import cat.hack3.codingtests.marsrover.api.cartography.PlanetMap;

public interface RotableRiderRover {
    enum Rotation {LEFT, RIGHT}

    void moveTowards(Direction direction);

    void rotateTowards(Rotation rotation);

    Coordinates getCurrentCoordinates();

    Direction getCurrentDirection();

    interface Provider {
        RotableRiderRover provideWith(PlanetMap map, Direction startingDirection);
    }
}
