package cat.hack3.codingtests.marsrover.commands;


import cat.hack3.codingtests.marsrover.api.RotableRiderRover;
import cat.hack3.codingtests.marsrover.api.commands.RoverCommand;
import cat.hack3.codingtests.marsrover.api.commands.RoverCommandFactory;

public class RoverCommandFactoryImpl implements RoverCommandFactory {
    private final RotableRiderRover rover;

    public static class Provider implements RoverCommandFactory.Provider {
        @Override
        public RoverCommandFactory provideWith(RotableRiderRover rover) {
            return new RoverCommandFactoryImpl(rover);
        }
    }

    private RoverCommandFactoryImpl(RotableRiderRover rover) {
        this.rover = rover;
    }

    @Override
    public RoverCommand create(RoverCommand.Type type) {
        return switch (type) {
            case MOVE_FORWARD -> new MoveForwardCommand(rover);
            case MOVE_BACKWARDS -> new MoveBackwardsCommand(rover);
            case TURN_LEFT -> new TurnLeftCommand(rover);
            case TURN_RIGHT -> new TurnRightCommand(rover);
        };
    }
}
